# Generated by the protocol buffer compiler.  DO NOT EDIT!
# sources: envoy/extensions/access_loggers/open_telemetry/v3/logs_service.proto
# plugin: python-betterproto
# This file has been @generated

from dataclasses import dataclass
from typing import List

import betterproto

from ......opentelemetry.proto.common import v1 as _____opentelemetry_proto_common_v1__
from .....config.core import v3 as ____config_core_v3__
from ...grpc import v3 as __grpc_v3__


@dataclass(eq=False, repr=False)
class OpenTelemetryAccessLogConfig(betterproto.Message):
    """
    Configuration for the built-in ``envoy.access_loggers.open_telemetry``
    :ref:`AccessLog <envoy_v3_api_msg_config.accesslog.v3.AccessLog>`. This
    configuration will populate `opentelemetry.proto.collector.v1.logs.ExportLo
    gsServiceRequest.resource_logs <https://github.com/open-
    telemetry/opentelemetry-proto/blob/main/opentelemetry/proto/collector/logs/
    v1/logs_service.proto>`_. In addition, the request start time is set in the
    dedicated field. [#extension: envoy.access_loggers.open_telemetry] [#next-
    free-field: 8]
    """

    common_config: "__grpc_v3__.CommonGrpcAccessLogConfig" = betterproto.message_field(
        1
    )
    """
    [#comment:TODO(itamarkam): add 'filter_state_objects_to_log' to logs.]
    """

    disable_builtin_labels: bool = betterproto.bool_field(5)
    """
    If specified, Envoy will not generate built-in resource labels like
    ``log_name``, ``zone_name``, ``cluster_name``, ``node_name``.
    """

    resource_attributes: "_____opentelemetry_proto_common_v1__.KeyValueList" = (
        betterproto.message_field(4)
    )
    """
    OpenTelemetry `Resource <https://github.com/open-telemetry/opentelemetry-
    proto/blob/main/opentelemetry/proto/logs/v1/logs.proto#L51>`_ attributes
    are filled with Envoy node info. Example: ``resource_attributes { values {
    key: "region" value { string_value: "cn-north-7" } } }``.
    """

    body: "_____opentelemetry_proto_common_v1__.AnyValue" = betterproto.message_field(2)
    """
    OpenTelemetry `LogResource <https://github.com/open-
    telemetry/opentelemetry-
    proto/blob/main/opentelemetry/proto/logs/v1/logs.proto>`_ fields, following
    `Envoy access logging formatting <https://www.envoyproxy.io/docs/envoy/late
    st/configuration/observability/access_log/usage>`_. See 'body' in the
    LogResource proto for more details. Example: ``body { string_value:
    "%PROTOCOL%" }``.
    """

    attributes: "_____opentelemetry_proto_common_v1__.KeyValueList" = (
        betterproto.message_field(3)
    )
    """
    See 'attributes' in the LogResource proto for more details. Example:
    ``attributes { values { key: "user_agent" value { string_value: "%REQ(USER-
    AGENT)%" } } }``.
    """

    stat_prefix: str = betterproto.string_field(6)
    """
    Optional. Additional prefix to use on OpenTelemetry access logger stats. If
    empty, the stats will be rooted at
    ``access_logs.open_telemetry_access_log.``. If non-empty, stats will be
    rooted at ``access_logs.open_telemetry_access_log.<stat_prefix>.``.
    """

    formatters: List[
        "____config_core_v3__.TypedExtensionConfig"
    ] = betterproto.message_field(7)
    """
    Specifies a collection of Formatter plugins that can be called from the
    access log configuration. See the formatters extensions documentation for
    details. [#extension-category: envoy.formatter]
    """
