# Generated by the protocol buffer compiler.  DO NOT EDIT!
# sources: envoy/extensions/filters/http/json_to_metadata/v3/json_to_metadata.proto
# plugin: python-betterproto
# This file has been @generated

from dataclasses import dataclass
from typing import List

import betterproto
import betterproto.lib.google.protobuf as betterproto_lib_google_protobuf

from ......type.matcher import v3 as _____type_matcher_v3__


class JsonToMetadataValueType(betterproto.Enum):
    PROTOBUF_VALUE = 0
    """
    The value is a serialized `protobuf.Value <https://github.com/protocolbuffe
    rs/protobuf/blob/master/src/google/protobuf/struct.proto#L62>`_.
    """

    STRING = 1
    NUMBER = 2


@dataclass(eq=False, repr=False)
class JsonToMetadata(betterproto.Message):
    request_rules: "JsonToMetadataMatchRules" = betterproto.message_field(1)
    """
    At least one of request_rules and response_rules must be provided. Rules to
    match json body of requests.
    """

    response_rules: "JsonToMetadataMatchRules" = betterproto.message_field(2)
    """Rules to match json body of responses."""


@dataclass(eq=False, repr=False)
class JsonToMetadataKeyValuePair(betterproto.Message):
    """[#next-free-field: 6]"""

    metadata_namespace: str = betterproto.string_field(1)
    """
    The namespace — if this is empty, the filter's namespace will be used.
    """

    key: str = betterproto.string_field(2)
    """The key to use within the namespace."""

    value: "betterproto_lib_google_protobuf.Value" = betterproto.message_field(
        3, group="value_type"
    )
    """
    The value to pair with the given key. When used for on_present case, if
    value is non-empty it'll be used instead of the the value of the JSON key.
    If both are empty, the the value of the JSON key is used as-is. When used
    for on_missing/on_error case, a non-empty value must be provided. It
    ignores ValueType, i.e., not type casting.
    """

    type: "JsonToMetadataValueType" = betterproto.enum_field(4)
    """The value's type — defaults to protobuf.Value."""

    preserve_existing_metadata_value: bool = betterproto.bool_field(5)
    """
    False if we want to overwrite the existing metadata value. Default to
    false.
    """


@dataclass(eq=False, repr=False)
class JsonToMetadataSelector(betterproto.Message):
    key: str = betterproto.string_field(1, group="selector")
    """key to match"""


@dataclass(eq=False, repr=False)
class JsonToMetadataRule(betterproto.Message):
    """
    A Rule defines what metadata to apply when a key-value is present, missing
    in the json or fail to parse the payload.
    """

    selectors: List["JsonToMetadataSelector"] = betterproto.message_field(1)
    """
    Specifies that a match will be performed on the value of a property. Here's
    an example to match on 1 in {"foo": {"bar": 1}, "bar": 2} selectors: - key:
    foo - key: bar
    """

    on_present: "JsonToMetadataKeyValuePair" = betterproto.message_field(2)
    """If the attribute is present, apply this metadata KeyValuePair."""

    on_missing: "JsonToMetadataKeyValuePair" = betterproto.message_field(3)
    """
    If the attribute is missing, apply this metadata KeyValuePair. The value in
    the KeyValuePair must be set.
    """

    on_error: "JsonToMetadataKeyValuePair" = betterproto.message_field(4)
    """
    If the body is too large or fail to parse or content-type is mismatched,
    apply this metadata KeyValuePair. The value in the KeyValuePair must be
    set.
    """


@dataclass(eq=False, repr=False)
class JsonToMetadataMatchRules(betterproto.Message):
    rules: List["JsonToMetadataRule"] = betterproto.message_field(1)
    """The list of rules to apply."""

    allow_content_types: List[str] = betterproto.string_field(2)
    """
    Allowed content-type for json to metadata transformation. Default to
    ``{"application/json"}``. Set ``allow_empty_content_type`` if empty/missing
    content-type header is allowed.
    """

    allow_empty_content_type: bool = betterproto.bool_field(3)
    """
    Allowed empty content-type for json to metadata transformation. Default to
    false.
    """

    allow_content_types_regex: "_____type_matcher_v3__.RegexMatcher" = (
        betterproto.message_field(4)
    )
    """
    Allowed content-type by regex match for json to metadata transformation.
    This can be used in parallel with ``allow_content_types``.
    """
